// Code generated by "requestgen -method GET -responseType .APIResponse -responseDataField Data -type ListSymbolsRequest -url /api/v1/symbols -responseDataType []Symbol"; DO NOT EDIT.

package kucoinapi

import (
	"context"
	"encoding/json"
	"fmt"
	"net/url"
	"regexp"
)

func (l *ListSymbolsRequest) Market(market string) *ListSymbolsRequest {
	l.market = &market
	return l
}

// GetQueryParameters builds and checks the query parameters and returns url.Values
func (l *ListSymbolsRequest) GetQueryParameters() (url.Values, error) {
	var params = map[string]interface{}{}

	query := url.Values{}
	for k, v := range params {
		query.Add(k, fmt.Sprintf("%v", v))
	}

	return query, nil
}

// GetParameters builds and checks the parameters and return the result in a map object
func (l *ListSymbolsRequest) GetParameters() (map[string]interface{}, error) {
	var params = map[string]interface{}{}
	// check market field -> json key market
	if l.market != nil {
		market := *l.market

		// assign parameter of market
		params["market"] = market
	}

	return params, nil
}

// GetParametersQuery converts the parameters from GetParameters into the url.Values format
func (l *ListSymbolsRequest) GetParametersQuery() (url.Values, error) {
	query := url.Values{}

	params, err := l.GetParameters()
	if err != nil {
		return query, err
	}

	for k, v := range params {
		query.Add(k, fmt.Sprintf("%v", v))
	}

	return query, nil
}

// GetParametersJSON converts the parameters from GetParameters into the JSON format
func (l *ListSymbolsRequest) GetParametersJSON() ([]byte, error) {
	params, err := l.GetParameters()
	if err != nil {
		return nil, err
	}

	return json.Marshal(params)
}

// GetSlugParameters builds and checks the slug parameters and return the result in a map object
func (l *ListSymbolsRequest) GetSlugParameters() (map[string]interface{}, error) {
	var params = map[string]interface{}{}

	return params, nil
}

func (l *ListSymbolsRequest) applySlugsToUrl(url string, slugs map[string]string) string {
	for k, v := range slugs {
		needleRE := regexp.MustCompile(":" + k + "\\b")
		url = needleRE.ReplaceAllString(url, v)
	}

	return url
}

func (l *ListSymbolsRequest) GetSlugsMap() (map[string]string, error) {
	slugs := map[string]string{}
	params, err := l.GetSlugParameters()
	if err != nil {
		return slugs, nil
	}

	for k, v := range params {
		slugs[k] = fmt.Sprintf("%v", v)
	}

	return slugs, nil
}

func (l *ListSymbolsRequest) Do(ctx context.Context) ([]Symbol, error) {

	// empty params for GET operation
	var params interface{}
	query := url.Values{}

	apiURL := "/api/v1/symbols"

	req, err := l.client.NewRequest(ctx, "GET", apiURL, query, params)
	if err != nil {
		return nil, err
	}

	response, err := l.client.SendRequest(req)
	if err != nil {
		return nil, err
	}

	var apiResponse APIResponse
	if err := response.DecodeJSON(&apiResponse); err != nil {
		return nil, err
	}
	var data []Symbol
	if err := json.Unmarshal(apiResponse.Data, &data); err != nil {
		return nil, err
	}
	return data, nil
}
